#include <bits/stdc++.h>
using namespace std;

const long long MX=7e5+10;
long long mas[MX];

void fun()
{
    map < pair < long long , long long > , long long > mp;
    vector < pair < long long , long long > > al;

    long long n;
    cin>>n;

    for(long long i=2*n;i>=0;i--)
    {
        mas[i]=0;
    }

    for(long long i=1;i<=n;i++)
    {
        long long a,b,c;
        cin>>a>>b>>c;

        if(a>b)
        {
            swap(a,b);
        }

        mp[make_pair(a,b)]=c;

        mas[a]+=c;
        mas[b]+=c;
        al.push_back({a,b});
    }

    long long mx=0;
    for(long long i=1;i<=2*n;i++)
    {
        mx=max(mx,mas[i]);
    }

    for(long long i=0;i<n;i++)
    {
        for(long long j=i+1;j<n;j++)
        {
            if(al[i].first==al[j].first)
            {
                mx=max(mx,mp[al[i]]+mp[al[j]]+mp[make_pair(al[i].second,al[j].second)]);
            }
        }
    }

    cout<<mx<<"\n";
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    long long t;
    cin>>t;

    while(t--)
    {
        fun();
    }

    return 0;
}